import { Matrix } from '../util/matrix';
import { XYZHelper } from '../util/helpers';
import { FromRGBF } from './rgbf';
export class FromXYZ {
    static toRGBF(x, y, z) {
        const args = FromXYZ.resolveArguments(x, y, z);
        const result = {
            r: args.x * Matrix.XYZtosRGB.x[0] + args.y * Matrix.XYZtosRGB.x[1] + args.z * Matrix.XYZtosRGB.x[2],
            g: args.x * Matrix.XYZtosRGB.y[0] + args.y * Matrix.XYZtosRGB.y[1] + args.z * Matrix.XYZtosRGB.y[2],
            b: args.x * Matrix.XYZtosRGB.z[0] + args.y * Matrix.XYZtosRGB.z[1] + args.z * Matrix.XYZtosRGB.z[2]
        };
        result.r = XYZHelper.pivotXYZ(result.r);
        result.g = XYZHelper.pivotXYZ(result.g);
        result.b = XYZHelper.pivotXYZ(result.b);
        return result;
    }
    static toRGB8(x, y, z) {
        return FromRGBF.toRGB8(FromXYZ.toRGBF(x, y, z));
    }
    static resolveArguments(x, y, z) {
        const argumentType = typeof x;
        let result;
        if (argumentType === 'object' && x !== null) {
            result = { x: x.x, y: x.y, z: x.z };
        }
        else if (argumentType === 'number') {
            result = { x: x, y: y, z: z };
        }
        else {
            throw new TypeError('Unknown arguments passed');
        }
        return result;
    }
}
